/* Example: pointer as return value of functions */
/* Often used with arrays and strings */

#include <stdio.h>

char *tail(char *s, char c);  /* returns tail of s, from c on */

main()
{
  char str[] = "Introduction to Programming and \
Computer Architecture"; /* strings may be wrapped using '\' */

  char ch, *p;
  
  puts("Enter a character:");
  ch = getchar();
  
  p = tail(str, ch);
  
  if (p == NULL)
    puts("Not present in string.");
  else
    puts(p);
}


char *tail(char *s, char c)  /* returns tail of s, from c on */
{
  char *t = s;
  
  do      /* scan along s until c or '\0' is found */
  {
    if (*t == c)  
      return t;
  } while (*(t++) != '\0');

  return NULL; /* reached end of s, c not found. 
               NULL is an appropriate pointer value 
               to signal an error */
}
